/*********************************************************
* Conversion d'image RGB­> HSV > RGB
* Date: 24-Mai-2021
* Auteur: Yann Roberge
*********************************************************/

#include "rgb2hsv.h"

// Load raw image to memory

// Convert to HSV

// Add corrections

// Convert back to RGB

// Pass hue, saturation and value (lightness / 2) corrections to args

void rgb2hsv(PixelHSV* hsv, PixelRGB8* rgb) {
    int r = (int) rgb->red;
    int g = (int) rgb->green;
    int b = (int) rgb->blue;
    int minComp, maxComp;

    int tempSubtract, ampl;
    int offset = 64;

    // Min and Max color components
    if (r == 0 && g == 0 && b == 0) {
        hsv->hue = 0;
        hsv->sat = 0;
        hsv->value = 0;
        return;
    }
    else if (r >= g && r >= b) {
        maxComp = r;
        if (g < b) {
            minComp = g;
        }
        else {
            minComp = b;
        }
        tempSubtract = g - b;
    }
    else if (g >= b) {
        maxComp = g;
        if (r >= b) {
            minComp = b;
        }
        else {
            minComp = r;
        }
        tempSubtract = b - r;
        offset += 128;
    }
    else {
        maxComp = b;
        if (r >= g) {
            minComp = g;
        }
        else {
            minComp = r;
        }
        tempSubtract = r - g;
        offset += 256;
    }

    //H
    ampl = maxComp - minComp;
    if (ampl == 0) {
        // Grayscale color, hue doesn't matter
        hsv->hue = 0;
    }
    else {
        hsv->hue = (tempSubtract*64 / ampl) + offset;
    }

    //S
    if (maxComp == 0) {
        // Pitch black, saturation doesn't matter
        hsv->sat = 0;
    }
    else {
        hsv->sat = 1.0*ampl / maxComp;
    }

    //V
    hsv->value = maxComp;
}

void hsv2rgb(PixelRGB8* rgb, PixelHSV* hsv) {
    //TODO: Implémenter
}

